【POI2011】 Meteors 整体二分(写代码时的坑点)

Solution

这道题目算是整体二分的经典题目吧,一个询问的话暴力都可以,但多个怎么办?我们发现mid场流星雨后可行的国家只可能在l~mid场,不可行的只能在mid+1~r场,答案具有二分性,国家也可以二分,那么我们对两种国家分别递归即可。
Tips:
1.这道题目rlz老师讲的时候是差分,说快很多,其实还是树状数组,不能单纯的线扫,每次线扫的话要超时,应该是区间修改的树状数组中的差分。
2.每个国家的空间站要用链表(前向星)存储,否则TLE。
3.最关键的是关于mid的流星雨pd完后的递归,我们用类似莫队的方法,大减小加,这样你画出图后发现更新流星雨的时间约为3*K,很精妙,%hzwer。

CODE

/*
 * @key words: all_binary
 * @tested on: BZOJ 2527 luogu 3527 Meteors
 * @Author: LuHaoqi 
 * @Date: 2017-08-10 16:01:24 
 * @Last Modified by: LuHaoqi
 * @Last Modified time: 2017-08-10 16:03:31
 */
#include<bits/stdc++.h>
using namespace std;
#define ll long long
const int MAXN=300005,MAXM=300005,MAXK=300005,SIZE=300005;
int a[MAXN],b[MAXN],p[MAXN],ans[MAXN];
int Head[MAXN],n,m,k,tot,now;
ll c[SIZE];
bool flag[MAXN];

struct node{
    int l,r,x;
}s[MAXK];
struct Edge{
    int v,next;
}edge[MAXM];

inline int read()
{
    int x=0,f=1;char ch=getchar();
    while(ch<'0'||ch>'9'){if(ch=='-')f=-1;ch=getchar();}
    while(ch>='0'&&ch<='9'){x=x*10+ch-'0';ch=getchar();}
    return x*f;
}
void add_edge(int x,int y)
{
    edge[++tot]=(Edge){y,Head[x]};
    Head[x]=tot;
}
void ReadInfo()
{
    n=read(); m=read();
    for (int i=1;i<=m;i++) 
    {
        int x=read();
        add_edge(x,i);
    }
    for (int i=1;i<=n;i++) p[i]=read();
    k=read();
    for (int i=1;i<=k;i++)
    {
        int l,r,x;
        l=read(); r=read(); x=read();
        s[i]=(node){l,r,x};
    }
    s[k+1]=(node){1,n,1e9};
}
ll query(int x)
{
    ll ans=0;
    for (int i=x;i;i-=i & (-i)) ans+=c[i];
    return ans;
}
void add(int x,int val)
{
    for (int i=x;i<SIZE;i+=i & (-i)) c[i]+=(ll)val;
}
void update(int i,int f)
{
    int l=s[i].l,r=s[i].r,x=s[i].x;
    x=x*f;
    if (l<=r) add(l,x),add(r+1,-x);
    else add(1,x),add(r+1,-x),add(l,x),add(m+1,-x);
}
void all_ban(int x,int y,int l,int r)
{
    if (x>y) return;
    if (l==r) 
    {
        for (int i=x;i<=y;i++) ans[a[i]]=l;
        return;
    }
    int mid=(l+r)>>1,cnt=0;
    while (now<mid) now++,update(now,1);
    while (now>mid) update(now,-1),now--;
    for (int i=x;i<=y;i++)
    {
        int u=a[i]; ll sum=0;
        for (int j=Head[u];j;j=edge[j].next)
        {
            sum+=query(edge[j].v);
            if (sum>=p[u]) break;
        }
        if (sum>=p[u]) flag[i]=true,cnt++;
        else flag[i]=false;
    }
    int j=x,j2=x+cnt;
    for (int i=x;i<=y;i++)
        if (flag[i]) b[j++]=a[i];
        else b[j2++]=a[i];
    for (int i=x;i<=y;i++) a[i]=b[i];
    all_ban(x,j-1,l,mid);
    all_ban(j,y,mid+1,r);
}
void solve()
{
    now=0;
    for (int i=1;i<=n;i++) a[i]=i;
    all_ban(1,n,1,k+1);
    for (int i=1;i<=n;i++)
        if (ans[i]<=k) printf("%d\n",ans[i]);
        else printf("NIE\n");
}
int main()
{
    ReadInfo();
    solve();
    //system("pause");
    return 0;
}

Problem

BZOJ

2527: [Poi2011]Meteors

Time Limit: 60 Sec Memory Limit: 128 MB
Submit: 1720 Solved: 613
[Submit][Status][Discuss]
Description

Byteotian Interstellar Union (BIU) has recently discovered a new planet in a nearby galaxy. The planet is unsuitable for colonisation due to strange meteor showers, which on the other hand make it an exceptionally interesting object of study.
The member states of BIU have already placed space stations close to the planet’s orbit. The stations’ goal is to take samples of the rocks flying by. The BIU Commission has partitioned the orbit into msectors, numbered from 1to m, where the sectors 1and mare adjacent. In each sector there is a single space station, belonging to one of the nmember states.
Each state has declared a number of meteor samples it intends to gather before the mission ends. Your task is to determine, for each state, when it can stop taking samples, based on the meter shower predictions for the years to come.
Byteotian Interstellar Union有N个成员国。现在它发现了一颗新的星球,这颗星球的轨道被分为M份(第M份和第1份相邻),第i份上有第Ai个国家的太空站。
这个星球经常会下陨石雨。BIU已经预测了接下来K场陨石雨的情况。
BIU的第i个成员国希望能够收集Pi单位的陨石样本。你的任务是判断对于每个国家,它需要在第几次陨石雨之后,才能收集足够的陨石。
输入:
第一行是两个数N,M。
第二行有M个数,第i个数Oi表示第i段轨道上有第Oi个国家的太空站。
第三行有N个数,第i个数Pi表示第i个国家希望收集的陨石数量。
第四行有一个数K,表示BIU预测了接下来的K场陨石雨。
接下来K行,每行有三个数Li,Ri,Ai,表示第K场陨石雨的发生地点在从Li顺时针到Ri的区间中(如果Li<=Ri,就是Li,Li+1,…,Ri,否则就是Ri,Ri+1,…,m-1,m,1,…,Li),向区间中的每个太空站提供Ai单位的陨石样本。
输出:
N行。第i行的数Wi表示第i个国家在第Wi波陨石雨之后能够收集到足够的陨石样本。如果到第K波结束后仍然收集不到,输出NIE。
数据范围:
数据范围:
1<=n,m,k<=3*10^5
1<=Pi<=10^9
1<=Ai<10^9

Input

The first line of the standard input gives two integers, n and m(1<=n,m<=3*10^5) separated by a single space, that denote, respectively, the number of BIU member states and the number of sectors the orbit has been partitioned into.
In the second line there are mintegers Oi(1<=Oi<=n) separated by single spaces, that denote the states owning stations in successive sectors.
In the third line there are nintegers Pi(1<=Pi<=10^9) separated by single spaces, that denote the numbers of meteor samples that the successive states intend to gather.
In the fourth line there is a single integer k(1<=k<=3*10^5) that denotes the number of meteor showers predictions. The following klines specify the (predicted) meteor showers chronologically. The i-th of these lines holds three integers Li, Ri, Ai(separated by single spaces), which denote that a meteor shower is expected in sectors Li,Li+1,…Ri (if Li<=Ri) or sectors Li,Li+1,…,m,1,…Ri (if Li>Ri), which should provide each station in those sectors with Aimeteor samples (1<=Ai<10^9).
In tests worth at least 20% of the points it additionally holds that .
Output

Your program should print nlines on the standard output. The i-th of them should contain a single integer Wi, denoting the number of shower after which the stations belonging to the i-th state are expected to gather at least Pi samples, or the word NIE (Polish for no) if that state is not expected to gather enough samples in the foreseeable future.
Sample Input

3 5

1 3 2 1 3

10 5 7

3

4 2 4

1 3 1

3 5 2

Sample Output

3

NIE

1

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章